/**
 * 
 */
package edu.columbia.cs.irt.sipcloud;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.SQLException;
import java.sql.Statement;

/**
 * @author jyk
 *
 */
public class MysqlConnector {
	private Connection conn = null;
	
	private String SP = " ";
	private String insTmplBegin = "INSERT INTO records " +
			 "(domain_id,name,type,content,ttl,prio,change_date) " +
			 "VALUES (1,"; //domain_id
	private String insTmplEnd = ",120,5,NULL)";  // ttl, prio, change_date
	private String srvTcp = "'_sip._tcp.sip.epic911.net'";
	private String srvUdp = "'_sip._udp.sip.epic911.net'";
	
	private String delTmplBegin = "DELETE FROM records WHERE ";
	
	
	private String deleteString = null;
	
	public boolean connect() {
		boolean isSuccess = true;
		try {
			conn = 
				DriverManager.getConnection("jdbc:mysql://pdns.cs.columbia.edu/pdnstest?" +
											"user=pdns&password=irtlab7lw2");
		} catch (SQLException ex) {
			System.out.println("SQLException: " + ex.getMessage());
			System.out.println("SQLState: " + ex.getSQLState());
			System.out.println("VendorError: " + ex.getErrorCode());
			isSuccess = false;
		}
		return isSuccess;
	}
	
	public void close() {
		try {
			conn.close();
		} catch (SQLException ex) {
			System.out.println("SQLException: " + ex.getMessage());
			System.out.println("SQLState: " + ex.getSQLState());
			System.out.println("VendorError: " + ex.getErrorCode());
		}
		conn = null;
	}
	
	public boolean insertLBrecord(String lbName, String lbAddr, String lbPort) {
		boolean isSuccess = true;
		Statement stmt = null;
		String sqlA = null;
		String sqlSrvU = null;
		String sqlSrvT = null;
		try {
			sqlA = insTmplBegin + "'" + lbName + "'" + ",'A'," 
								+ "'" + lbAddr + "'" + insTmplEnd;
			sqlSrvT = insTmplBegin + srvTcp + ",'SRV','0 " 
						+ lbPort + SP + lbName + "'" + insTmplEnd;
			sqlSrvU = insTmplBegin + srvUdp + ",'SRV','0 " 
						+ lbPort + SP + lbName + "'" + insTmplEnd;
			
			//System.out.println(sqlA);
			//System.out.println(sqlSrvT);
			//System.out.println(sqlSrvU);
			
			stmt = conn.createStatement();
			stmt.executeUpdate(sqlA);
			stmt.executeUpdate(sqlSrvT);
			stmt.executeUpdate(sqlSrvU);
			
		} catch (SQLException ex) {
			System.out.println("SQLException: " + ex.getMessage());
			System.out.println("SQLState: " + ex.getSQLState());
			System.out.println("VendorError: " + ex.getErrorCode());
			isSuccess = false;
		} finally {
			// it is a good idea to release
			// resources in a finally{} block
			// in reverse-order of their creation
			// if they are no-longer needed			
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException sqlEx) { } // ignore
				stmt = null;
			}
		}
		return isSuccess;
	}
	
	public boolean deleteLBrecord(String lbName) {
		boolean isSuccess = true;
		Statement stmt = null;
		String sqlA = null;
		String sqlSrvU = null;
		String sqlSrvT = null;
		try {
			sqlA = delTmplBegin + "name LIKE '" + lbName + "'";
			sqlSrvT = delTmplBegin + "name LIKE " + srvTcp 
								   + " AND content LIKE '% " + lbName + "'";
			sqlSrvU = delTmplBegin + "name LIKE " + srvUdp 
			   					   + " AND content LIKE '% " + lbName + "'";
			
			System.out.println(sqlA);
			System.out.println(sqlSrvT);
			System.out.println(sqlSrvU);
			
			stmt = conn.createStatement();
			stmt.executeUpdate(sqlA);
			stmt.executeUpdate(sqlSrvT);
			stmt.executeUpdate(sqlSrvU);
			
		} catch (SQLException ex) {
			System.out.println("SQLException: " + ex.getMessage());
			System.out.println("SQLState: " + ex.getSQLState());
			System.out.println("VendorError: " + ex.getErrorCode());
			isSuccess = false;
		} finally {
			// it is a good idea to release
			// resources in a finally{} block
			// in reverse-order of their creation
			// if they are no-longer needed			
			if (stmt != null) {
				try {
					stmt.close();
				} catch (SQLException sqlEx) { } // ignore
				stmt = null;
			}
		}
		return isSuccess;
	}
}
