#!/bin/sh
rm -rf LoadScalingManager.app

mkdir LoadScalingManager.app
mkdir LoadScalingManager.app/Contents
mkdir LoadScalingManager.app/Contents/Resources
mkdir LoadScalingManager.app/Contents/MacOS
mkdir LoadScalingManager.app/Contents/MacOS/res

cp res/*.png LoadScalingManager.app/Contents/MacOS/res
cp LoadScalingManager.icns LoadScalingManager.app/Contents/Resources

cp LoadScalingManager_fat.jar LoadScalingManager.app/Contents/MacOS/
#-Xdock:icon=rsrc/ui/icon/desktop.icns 
echo "#!/bin/sh
APPDIR=/Applications/LoadScalingManager.app
cd \$APPDIR/Contents/MacOS
/System/Library/Java/JavaVirtualMachines/1.6.0.jdk/Contents/Home/bin/java -d32 -XstartOnFirstThread -Xdock:name=\"LoadScalingManager\" -jar LoadScalingManager_fat.jar" > LoadScalingManager.app/Contents/MacOS/LoadScalingManager

echo '<?xml version="1.0" encoding="UTF-8"?>
<!DOCTYPE plist SYSTEM "file://localhost/System/Library/DTDs/PropertyList.dtd">
<plist version="1.0">
<dict>
    <key>CFBundleName</key>
    <string>LoadScalingManager</string>
    <key>CFBundleVersion</key>
    <string>1.0</string>
    <key>CFBundleAllowMixedLocalizations</key>
    <string>false</string>
    <key>CFBundleGetInfoString</key>
    <string>LoadScalingManager 20120331</string>
    <key>CFBundleInfoDictionaryVersion</key>
    <string>6.0</string>
    <key>CFBundleExecutable</key>
    <string>LoadScalingManager</string>
    <key>CFBundleDevelopmentRegion</key>
    <string>English</string>
    <key>CFBundlePackageType</key>
    <string>APPL</string>
    <key>CFBundleSignature</key>
    <string>????</string>
    <key>CFBundleIconFile</key>
    <string>LoadScalingManager.icns</string>
</dict>
</plist>' > LoadScalingManager.app/Contents/Info.plist

chmod +x LoadScalingManager.app/Contents/MacOS/LoadScalingManager

rm -rf /Applications/LoadScalingManager.app
mv LoadScalingManager.app /Applications/
rm -rf LoadScalingManager_fat.jar
