/**
 * 
 */
package edu.columbia.cs.irt.sipcloud;

import edu.columbia.cs.irt.sipcloud.gui.MainWindow;

/**
 * @author jyk
 *
 */
public class Main {

	/**
	 * Launch the application.
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			LoadScalingManager lsm = new LoadScalingManager();
			lsm.start();
		
			MainWindow window = new MainWindow();
			window.setLsm(lsm);
			window.open();
			
			lsm.keepRunning = false;
			
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}
